﻿using System;
using System.Collections.Generic;

namespace StepIII.OrderStates
{
    internal class Paid : OrderState
    {
        public Paid(IEnumerable<OrderLine> orderLines, ShippingDetails shippingDetails, InvoiceDetails invoiceDetails)
            : base(orderLines, shippingDetails, invoiceDetails)
        {
        }

        public override OrderState AddOrderLine(string description, decimal price)
        {
            throw new NotImplementedException();
        }

        public override OrderState Cancel()
        {
            throw new NotImplementedException();
        }

        public override OrderState FinalizeOrder()
        {
            throw new NotImplementedException();
        }

        public override OrderState Pay()
        {
            throw new NotImplementedException();
        }

        public override OrderState RemoveOrderLine(Guid orderlineIdentifier)
        {
            throw new NotImplementedException();
        }

        public override OrderState ShipOrder()
        {

            VerifyShippingDetails();

            var shippingDate = _shippingGateway.DetermineShippingDate(this);
            _shippingDetails.SetShippingDate(shippingDate);


            return new Shipped(_orderlines, _shippingDetails, _invoiceDetails);
        }

        private void VerifyShippingDetails()
        {
            ; // Let's pretend that everything is in order (pun intended)
        }
    }
}
